<?php

namespace Drupal\ecc;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Entity\EntityAccessControlHandler;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Session\AccountInterface;

/**
 * Defines a custom implementation for ECC entity access control handler.
 */
class EccAccessControlHandler extends EntityAccessControlHandler {

  /**
   * {@inheritdoc}
   */
  protected function checkAccess(EntityInterface $entity, $operation, AccountInterface $account) {
    $ecc_type = $entity->get('type')->entity;
    if ($operation === 'delete' && $ecc_type->get('keep_ecc_config')) {
      if (!$account->hasPermission('bypass removing ecc entities')) {
        return AccessResult::forbidden()->addCacheableDependency($ecc_type);
      }
    }

    return parent::checkAccess($entity, $operation, $account);
  }

}
